Index: trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2792)
+++ trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2794)
@@ -389,38 +716,27 @@
              min_h2o_ice_s_2,iim,jjm,ngrid,tendencies_h2o_ice_phys)
 
-!  Compute the tendencies of the evolution of co2 ice over the years
-
       call compute_tendencies(tendencies_co2_ice,min_co2_ice_s_1,&
              min_co2_ice_s_2,iim,jjm,ngrid,tendencies_co2_ice_phys)
 
-!  Compute the tendencies of the evolution of water ice over the years with slopes
-
       call compute_tendencies_slope(tendencies_co2_ice_slope,min_co2_ice_slope_1,&
              min_co2_ice_slope_2,iim,jjm,ngrid,tendencies_co2_ice_phys_slope,nslope)
 
-!  Compute the tendencies of the evolution of co2 ice over the years with slopes
+
+      tendencies_co2_ice_phys_slope_ini(:,:)=tendencies_co2_ice_phys_slope(:,:)
 
       call compute_tendencies_slope(tendencies_h2o_ice_slope,min_h2o_ice_slope_1,&
              min_h2o_ice_slope_2,iim,jjm,ngrid,tendencies_h2o_ice_phys_slope,nslope)
 
-!------------------------
-
-! II  Run
-!    II_a Compute tendencies
-!    II_b Save initial situation
-
-!------------------------
-
+     
 !----- Save initial situation
 
      allocate(initial_h2o_ice(ngrid))
-
      allocate(initial_co2_ice(ngrid))
-     allocate(q_co2_GCM(ngrid))
-
+     allocate(initial_co2_ice_sublim_slope(ngrid,nslope))
      allocate(initial_co2_ice_slope(ngrid,nslope))
      allocate(initial_h2o_ice_slope(ngrid,nslope))
-
-! We save the places where water/co2 ice is sublimating
+     year_iter=0
+
+! We save the places where water ice is sublimating
   do i=1,ngrid
       if (tendencies_h2o_ice_phys(i).LT.0) then
@@ -432,4 +748,9 @@
 
       if (tendencies_co2_ice_phys_slope(i,islope).LT.0) then
+         initial_co2_ice_sublim_slope(i,islope)=1.
+      else
+         initial_co2_ice_sublim_slope(i,islope)=0.         
+      endif
+      if (co2ice_slope(i,islope).GT.0) then
          initial_co2_ice_slope(i,islope)=1.
       else
@@ -449,5 +770,4 @@
   ini_surf_h2o=0.
   Total_surface=0.
-
   do i=1,ngrid
     if (initial_h2o_ice(i).GT.0.5) then
@@ -455,5 +775,5 @@
     endif
     do islope=1,nslope
-      if (initial_co2_ice_slope(i,islope).GT.0.5) then
+      if (initial_co2_ice_sublim_slope(i,islope).GT.0.5) then
          ini_surf_co2=ini_surf_co2+cell_area(i)*subslope_dist(i,islope)
       endif
@@ -465,118 +785,232 @@
   enddo
 
-! We put the pressure on the physical grid
-
-  allocate(ps_phys(ngrid))
-
-  ig0 = iim+1
-  ps_phys(1)=ps(ig0)
-  ig0=ig0+1
-
-  DO i = 2, ngrid-1
-     if(modulo(ig0,iim+1).eq.0 .and. i.gt.3) then
-       ig0=ig0+1
-     endif
-     ps_phys(i) = ps(ig0)
-     ig0= ig0 + 1
-  ENDDO
-
-  ps_phys(ngrid)=ps(ig0)
-
-! We compute the global average pressure of the initial state
-
-  global_ave_press_old=0.
-  do i=1,ngrid
-    global_ave_press_old=global_ave_press_old+cell_area(i)*ps_phys(i)/Total_surface
-  enddo
-
-  global_ave_press_GCM=global_ave_press_old
-
-! We compute the initial pressure level
-
+     print *, "ini_surf_co2=", ini_surf_co2
+     print *, "ini_surf=", ini_surf
+     print *, "ini_surf_h2o=", ini_surf_h2o
+
+
+     allocate(local_old_press(ngrid))
+     allocate(local_new_press(ngrid))
+    
      allocate(zplev_new(ngrid,nlayer+1))
      allocate(zplev_old(ngrid,nlayer+1))
 
+
+     global_ave_press_old=0.
+     do i=1,ngrid
+       global_ave_press_old=global_ave_press_old+cell_area(i)*ps_phys(i)/Total_surface
+     enddo
+
+     global_ave_press_GCM=global_ave_press_old
+     print *, "global_ave_press_old", global_ave_press_old
+     
+
+
+!----- Time loop
+     print *, "Before timeloop"
+     allocate(flag_co2flow(ngrid,nslope))
+     allocate(flag_co2flow_mesh(ngrid))
+
+     firstcall=.TRUE.
+
+
+
+
+
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def , run_pem.def
+!    I_b READ starfi_0.nc
+!    I_c READ GCM data and convert to the physical grid 
+!    I_d Compute tendencies & Save initial situation
+!    I_e Read startfi_PEM
+
+!------------------------
+
+
+! now we complete with the PEMstart
+
+      call pemetat0(.false.,"startfi_PEM.nc",ngrid,nsoilmx,nsoilmx_PEM,nslope,timelen,timestep,TI_PEM,tsoil_ave_phys_yr1,tsoil_PEM,ice_depth, &
+      tsurf_ave_phys_yr1, tsurf_ave_phys, q_co2_PEM_phys, q_h2o_PEM_phys,ps_phys_timeseries_yr1,ps_phys_timeseries,tsurf_phys_GCM_timeseries,tsoil_phys_PEM_timeseries,&
+      tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope,co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:), co2_adsorbded_phys,delta_co2_adsorbded)
+totmass_adsorbded = 0.
+     do ig = 1,ngrid
+      do islope =1, nslope
+       do l = 1,nsoilmx_PEM - 1
+
+          totmass_adsorbded = totmass_adsorbded + co2_adsorbded_phys(ig,l,islope)*(layer_PEM(l+1) - layer_PEM(l))* &
+          subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.) * &
+          cell_area(ig)
+       enddo
+
+      enddo
+
+     enddo
+
+     write(*,*) "tot mass in the regolith", totmass_adsorbded
+     stop
+     deallocate(tsurf_ave_phys_yr1)
+     deallocate(ps_phys_timeseries_yr1)
+     deallocate(tsoil_ave_phys_yr1)    
+
+
+!--------------------------- END INITIALISATION ---------------------
+
+
+
+
+!---------------------------- RUN ---------------------
+
+
+
+
+!------------------------
+
+! II  Run
+!    II_a update pressure,ice and tracers 
+
+!------------------------
+
+    
+     do while (.true.)
+! II.a.1. global pressure
+     global_ave_press_new=global_ave_press_old
+
+     do i=1,ngrid
+       do islope=1,nslope
+           global_ave_press_new=global_ave_press_new-g*cell_area(i)*tendencies_co2_ice_phys_slope(i,islope)*subslope_dist(i,islope)/cos(pi*def_slope_mean(islope)/180.)/Total_surface
+       enddo
+     
+      global_ave_press_new = global_ave_press_new -g*cell_area(i)*delta_co2_adsorbded(i)/Total_surface
+     enddo
+! II.a.2. tracers
+     allocate(zplev_old_timeseries(ngrid,nlayer+1,timelen))
         DO l=1,nlayer+1
-         DO ig=1,ip1jmp1
-          zplev_old(ig,l) = ap(l)  + bp(l)*ps(ig)
+         DO ig=1,ngrid
+          zplev_old(ig,l) = ap(l)  + bp(l)*ps_phys(ig)
+          zplev_old_timeseries(ig,l,:) = ap(l)  + bp(l)*ps_phys_timeseries(ig,:)
          ENDDO
         ENDDO
 
-
-!=======================================================
+     do i=1,ip1jmp1
+
+       ps(i)=ps(i)*global_ave_press_new/global_ave_press_old
+
+     enddo
+     do i = 1,ngrid
+       ps_phys(i)=ps_phys(i)*global_ave_press_new/global_ave_press_old
+       ps_phys_timeseries(i,:) = ps_phys_timeseries(i,:)*global_ave_press_new/global_ave_press_old
+     enddo
+
+     allocate(zplev_new_timeseries(ngrid,nlayer+1,timelen))
+
+        do l=1,nlayer+1
+         do ig=1,ngrid
+          zplev_new(ig,l) = ap(l)  + bp(l)*ps_phys(ig)
+          zplev_new_timeseries(ig,l,:)  = ap(l)  + bp(l)*ps_phys_timeseries(ig,:)
+         enddo
+        enddo
+
+
+      print *, "1 is okay"
+
+        DO nnq=1,nqtot
+        if (noms(nnq).NE."co2") then
+          DO l=1,llm-1
+            DO ig=1,ngrid
+               q(ig,l,nnq)=q(ig,l,nnq)*(zplev_old(ig,l)-zplev_old(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))
+            ENDDO
+            q(:,llm,nnq)=q(:,llm-1,nnq)
+          ENDDO
+        else
+          DO l=1,llm-1
+            DO ig=1,ngrid
+                q(ig,l,nnq)=q(ig,l,nnq)*(zplev_old(ig,l)-zplev_old(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))  &
+                                + (   (zplev_new(ig,l)-zplev_new(ig,l+1))  -       &
+                                      (zplev_old(ig,l)-zplev_old(ig,l+1))     )  / &
+                                      (zplev_new(ig,l)-zplev_new(ig,l+1))
+            ENDDO
+           q(:,llm,nnq)=q(:,llm-1,nnq)
+          ENDDO
+        endif
+        ENDDO
+
+
+ DO nnq=1,nqtot
+       DO ig=1,ngrid
+         DO l=1,llm-1
+          if(q(ig,l,nnq).GT.1 .and. (noms(nnq).NE."dust_number" .or. noms(nnq).NE."ccn_number") ) then
+              extra_mass=(q(ig,l,nnq)-1)*(zplev_new(ig,l)-zplev_new(ig,l+1))
+              q(ig,l,nnq)=1.
+              q(ig,l+1,nnq)=q(ig,l+1,nnq)+extra_mass*(zplev_new(ig,l+1)-zplev_new(ig,l+2))
+          endif
+          if(q(ig,l,nnq).LT.0) then
+              q(ig,l,nnq)=1E-30
+          endif
+         ENDDO
+       enddo
+   enddo
+
+
+
+
+  l=1
+  DO ig=1,ngrid
+      DO t = 1, timelen
+
+         q_h2o_PEM_phys(ig,t)=q_h2o_PEM_phys(ig,t)*(zplev_old_timeseries(ig,l,t)-zplev_old_timeseries(ig,l+1,t))/(zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))
+         if(q_h2o_PEM_phys(ig,t).LT.0) then
+           q_h2o_PEM_phys(ig,t)=1E-30
+         endif
+         if(q_h2o_PEM_phys(ig,t).GT.1) then
+           q_h2o_PEM_phys(ig,t)=1.
+         endif
+
+   enddo
+  enddo
+
+
+
+  DO ig=1,ngrid
+      DO t = 1, timelen
+         q_co2_PEM_phys(ig,t)=q_co2_PEM_phys(ig,t)*(zplev_old_timeseries(ig,l,t)-zplev_old_timeseries(ig,l+1,t))/(zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))  &
+                                + (   (zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))  -       &
+                                      (zplev_old_timeseries(ig,l,t)-zplev_old_timeseries(ig,l+1,t))     )  / &
+                                      (zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))
+         if (q_co2_PEM_phys(ig,t).LT.0) then
+              q_co2_PEM_phys(ig,t)=1E-30
+         elseif (q_co2_PEM_phys(ig,t).GT.1) then
+              q_co2_PEM_phys(ig,t)=1.
+         endif
+         mmean=1/(A*q_co2_PEM_phys(ig,t) +B)
+         vmr_co2_pem_phys(ig,t) = q_co2_PEM_phys(ig,t)*mmean/m_co2
+      ENDDO
+  ENDDO
+   
+     deallocate(zplev_new_timeseries)
+     deallocate(zplev_old_timeseries)
+
+
+! II.a.3. Evolution of the ice
+
+
+     call evol_h2o_ice_s_slope(qsurf_slope(:,igcm_h2o_ice,:),tendencies_h2o_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_water,nslope)
+      print *, "4 is okay"
+
+     call evol_co2_ice_s_slope(co2ice_slope,tendencies_co2_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_co2,nslope)
+      print *, "5 is okay"
+
 
 !------------------------
 
 ! II  Run
-!    II_a Compute tendencies
-!    II_b Save initial situation
-!    II_c Time loop
-
-!------------------------
-
-
-!----- Time loop
-
-     year_iter=0
-
-     do while (.true.)
-
-! Compute the new global average pressure given the tendencies of co2 condensation
-     global_ave_press_new=global_ave_press_old
-     do i=1,ngrid
-       do islope=1,nslope
-           global_ave_press_new=global_ave_press_new-dt_pem*g*cell_area(i)*tendencies_co2_ice_phys_slope(i,islope)*subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)/Total_surface
-       enddo
-     enddo
-
-! Compute the new surface pressure at each physical point
-     do i=1,ngrid
-       ps_phys(i)=ps_phys(i)*global_ave_press_new/global_ave_press_old
-     enddo
-
-! Compute the new surface pressure at each dynamical point
-     do i=1,ip1jmp1
-       ps(i)=ps(i)*global_ave_press_new/global_ave_press_old
-     enddo
-
-! Compute the new pressure level at each physical point
-
-     DO l=1,nlayer+1
-       DO ig=1,ip1jmp1
-        zplev_new(ig,l) = ap(l)  + bp(l)*ps(ig)
-       ENDDO
-     ENDDO
-
-! Compute the new values of tracer given the change of pressure and pressure level
-
-     DO nnq=1,nqtot      ! For each tracer
-      if (nnq.NE.1) then ! If it is not co2
-        DO l=1,llm-1     ! For each level
-          DO i=1,ip1jmp1 ! Each point
-             q(i,l,nnq)=q(i,l,nnq)*(zplev_old(ig,l)-zplev_old(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))
-          ENDDO          ! i loop
-          q(:,llm,nnq)=q(:,llm-1,nnq)
-        ENDDO            ! l loop
-      else               ! If it is co2
-        DO l=1,llm-1     ! For each level
-          DO i=1,ip1jmp1 ! Each point
-              q(i,l,nnq)=q(i,l,nnq)*(zplev_old(ig,l)-zplev_old(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))  &
-                              + (   (zplev_new(ig,l)-zplev_new(ig,l+1))  -       &
-                                    (zplev_old(ig,l)-zplev_old(ig,l+1))     )  / &
-                                    (zplev_new(ig,l)-zplev_new(ig,l+1))
-          ENDDO          ! i loop
-         q(:,llm,nnq)=q(:,llm-1,nnq)
-        ENDDO            ! l loop
-      endif
-     ENDDO               ! nnq loop
-
-
-!We apply the tendency on the ice
-
-     call evol_h2o_ice_s_slope(qsurf_slope(:,6,:),tendencies_h2o_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_water,nslope)
-
-     call evol_co2_ice_s_slope(co2ice_slope,tendencies_co2_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_co2,nslope)
-
-! FLOW : Make the co2 ice flow
+!    II_a update pressure, ice and tracers 
+!    II_b CO2 glaciers flows 
+
+!------------------------
+
+    
+
 
        DO ig = 1,ngrid
@@ -619,44 +1053,231 @@
              flag_co2flow_mesh(ig) = 1.
             ENDIF ! co2ice > hmax
-          ENDIF ! iflat
+          ENDIF ! iflattsoil_lope
         ENDDO !islope 
        ENDDO !ig
 
-
-! End of FLOW
-
-! We recompute the tendencies of co2 given the new surface pressure
-
-    call recomp_tend_co2_slope(tendencies_co2_ice_phys_slope,vmr_co2_gcm_phys,ps_GCM_2,global_ave_press_GCM,global_ave_press_new,timelen,ngrid,nslope)
-
+      print *, "6 is okay"
+
+!------------------------
+
+! II  Run
+!    II_a update pressure, ice and tracers 
+!    II_b CO2 glaciers flows 
+!    II_c Update surface and soil temperatures
+
+!------------------------
+
+
+! II_c.1 Update Tsurf
+      bool_sublim=0
+      Tsurfave_before_saved(:,:) = tsurf_ave_phys(:,:)
+       DO ig = 1,ngrid
+        DO islope = 1,nslope
+           if(initial_co2_ice_slope(ig,islope).gt.0.5 .and. co2ice_slope(ig,islope).LT. 1E-5) THEN !co2ice disappeared, look for closest point without co2ice
+
+
+              if(latitude_deg(ig).gt.0) then
+                do ig_loop=ig,ngrid
+                  DO islope_loop=islope,iflat,-1
+                     if(initial_co2_ice_slope(ig_loop,islope_loop).lt.0.5 .and. co2ice_slope(ig_loop,islope_loop).LT. 1E-5) then
+                            tsurf_ave_phys(ig,islope)=tsurf_ave_phys(ig_loop,islope_loop)
+                            bool_sublim=1
+                            exit
+                     endif
+                  enddo
+                  if (bool_sublim.eq.1) then
+                   exit
+                  endif
+                enddo
+              else
+               do ig_loop=ig,1,-1
+                  DO islope_loop=islope,iflat
+                     if(initial_co2_ice_slope(ig_loop,islope_loop).lt.0.5 .and. co2ice_slope(ig_loop,islope_loop).LT. 1E-5) then
+                            tsurf_ave_phys(ig,islope)=tsurf_ave_phys(ig_loop,islope_loop)
+                            bool_sublim=1
+                            exit
+                     endif
+                  enddo
+                  if (bool_sublim.eq.1) then
+                   exit
+                  endif
+                enddo
+
+              endif
+              initial_co2_ice_slope(ig,islope)=0
+
+              if ((co2ice_slope(ig,islope).lt.1e-5).and. (qsurf_slope(ig,igcm_h2o_ice,islope).gt.frost_albedo_threshold))  then
+                 
+               albedo_slope(ig,1,islope) = albedo_h2o_frost
+               albedo_slope(ig,2,islope) = albedo_h2o_frost
+
+              else
+                            
+               albedo_slope(ig,1,islope) = albedodat(ig)
+               albedo_slope(ig,2,islope) = albedodat(ig) 
+               emiss_slope(ig,islope) = emissiv         
+
+              endif
+
+           elseif( co2ice_slope(ig,islope).GT. 1E-5) THEN !Put tsurf as tcond co2
+  
+             ave=0.
+             do t=1,timelen
+              if(co2_ice_GCM_phys_slope(ig,islope,t).gt.1e-5) then
+                 ave = ave + beta/(alpha-log(vmr_co2_pem_phys(ig,t)*ps_phys_timeseries(ig,t)/100.))
+              else
+                 ave = ave + tsurf_phys_GCM_timeseries(ig,islope,t)
+              endif
+             enddo
+
+             tsurf_ave_phys(ig,islope)=ave/timelen
+           endif
+        enddo
+       enddo
+
+      print *, "7 is okay"
+   
+     do t = 1,timelen
+     tsurf_phys_GCM_timeseries(:,:,t) = tsurf_phys_GCM_timeseries(:,:,t) +( tsurf_ave_phys(:,:) -Tsurfave_before_saved(:,:)) 
+     enddo
+! for the start
+     do ig = 1,ngrid
+      do islope = 1,nslope
+     tsurf_slope(ig,islope) =  tsurf_slope(ig,islope) - (Tsurfave_before_saved(ig,islope)-tsurf_ave_phys(ig,islope))
+     enddo
+     enddo
+
+! II_c.2 Update soil temperature
+
+allocate(TI_locslope(ngrid,nsoilmx_PEM))
+allocate(Tsoil_locslope(ngrid,nsoilmx_PEM))
+allocate(Tsurf_locslope(ngrid))
+allocate(alph_locslope(ngrid,nsoilmx_PEM-1))
+allocate(beta_locslope(ngrid,nsoilmx_PEM-1))
+
+
+
+
+print *,"8 is ok"
+
+! Soil averaged
+  do islope = 1,nslope
+     TI_locslope(:,:) = TI_PEM(:,:,islope)
+     Tsoil_locslope(:,:) = tsoil_PEM(:,:,islope)
+     Tsurf_locslope(:) = tsurf_ave_phys(:,islope)
+     alph_locslope(:,:) = alph_PEM(:,:,islope)
+     beta_locslope(:,:) = beta_PEM(:,:,islope)
+     call soil_pem(ngrid,nsoilmx_PEM,.true.,TI_locslope,timestep,Tsurf_locslope,Tsoil_locslope,alph_locslope,beta_locslope)
+     call soil_pem(ngrid,nsoilmx_PEM,.false.,TI_locslope,timestep,Tsurf_locslope,Tsoil_locslope,alph_locslope,beta_locslope)
+     do t = 1,timelen
+       tsoil_phys_PEM_timeseries(:,:,islope,t) =  tsoil_phys_PEM_timeseries(:,:,islope,t) + (Tsoil_locslope(:,:)- tsoil_PEM(:,:,islope))
+     enddo
+     TI_PEM(:,:,islope) = TI_locslope(:,:)
+     tsoil_PEM(:,:,islope) = Tsoil_locslope(:,:)
+     tsurf_ave_phys(:,islope)  =  Tsurf_locslope(:)
+     alph_PEM(:,:,islope) = alph_locslope(:,:)
+     beta_PEM(:,:,islope) = beta_locslope(:,:)
+  enddo
+
+
+      print *, "9 is okay"
+
+
+!!!!!! Check for the time series
+
+   
+      do ig = 1,ngrid
+       do islope = 1,nslope
+         do iloop = 1,nsoilmx_PEM
+ 
+         if(isnan(tsoil_PEM(ig,iloop,islope))) then
+          write(*,*) "is nan tsoil", ig, iloop, islope, tsoil_PEM(ig,iloop,islope)
+           stop 
+         endif
+         enddo
+        enddo
+      enddo
+
+
+write(*,*) "before ice table, no stop"
+
+! II_c.3 Update the ice table
+     call computeice_table(timelen,ngrid,nslope,nsoilmx,nsoilmx_PEM, tsoil_phys_PEM_timeseries,tsurf_phys_GCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys, & 
+                           ps_phys_timeseries, ice_depth)
+       
+      print *, "10 is okay"
+! II_c.3 Update the soil thermal properties
+      call update_soil(ngrid,nslope,nsoilmx_PEM,tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope,co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:),ps_phys, &
+        cell_area,ice_depth,TI_PEM)
+
+! II_c.4 Update the mass of the regolith adsorbded
+   
+  
+   call regolith_co2adsorption(ngrid,nslope,nsoilmx_PEM,timelen,ps_phys_timeseries,tsoil_PEM,TI_PEM,tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope, & 
+                               co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:), q_co2_PEM_phys,q_h2o_PEM_phys,co2_adsorbded_phys,delta_co2_adsorbded)
+
+
+!------------------------
+
+! II  Run
+!    II_a update pressure, ice and tracers 
+!    II_b CO2 glaciers flows 
+!    II_c Update surface and soil temperatures
+!    II_d Update the tendencies and stopping criterion
+
+!------------------------
+
+
+      call recomp_tend_co2_slope(tendencies_co2_ice_phys_slope,tendencies_co2_ice_phys_slope_ini,vmr_co2_gcm_phys,vmr_co2_pem_phys,ps_phys_timeseries,&     
+                               global_ave_press_GCM,global_ave_press_new,timelen,ngrid,nslope)
+
+          print *, "12 is okay"
       year_iter=year_iter+dt_pem
 
-! We check if we should stop : the criterion is based on the area of ice that is sublimating
-
-      call criterion_ice_stop_water_slope(cell_area,ini_surf_h2o,qsurf_slope(:,6,:),STOPPING_water,ngrid,initial_h2o_ice)
-
-      call criterion_ice_stop_slope(cell_area,ini_surf_co2,co2ice_slope,STOPPING_co2,ngrid,initial_co2_ice_slope,global_ave_press_GCM,global_ave_press_new,nslope)
+!We check with we should stop
+
+
+      call criterion_ice_stop_water_slope(cell_area,ini_surf_h2o,qsurf_slope(:,igcm_h2o_ice,:),STOPPING_water,ngrid,initial_h2o_ice_slope)
+
+
+          print *, "13 is okay"
+      call criterion_ice_stop_slope(cell_area,ini_surf_co2,co2ice_slope,STOPPING_co2,ngrid,initial_co2_ice_sublim_slope,global_ave_press_GCM,global_ave_press_new,nslope)
+
+ print *, "criterion ok"
+
 
       print *, "STOPPING_water", STOPPING_water, "STOPPING1_water", STOPPING_1_water
       print *, "STOPPING_co2", STOPPING_co2, "STOPPING1_co2", STOPPING_1_co2
       print *, "year_iter=", year_iter
-
-      year=year+dt_pem
-
-! We check if the orbits parameters have changed too much
-      call orbit_param(year)
-
       if (STOPPING_water .or. STOPPING_1_water .or. STOPPING_co2 .or. STOPPING_1_co2)  then
         exit
       endif
 
-! Preparing for next iteration
       global_ave_press_old=global_ave_press_new
       zplev_old=zplev_new
 
 
-      enddo
-
-! We put the correct thickness of co2ice given the slope
+      enddo  ! big loop of the pem
+
+
+!---------------------------- END RUN PEM ---------------------
+
+
+
+
+!---------------------------- OUTPUT ---------------------
+
+
+
+
+!------------------------
+
+! III Output
+!    III_a Recomp tendencies for the start and startfi
+
+!------------------------
+
+
+! III_a.1 Ice update
       DO ig = 1,ngrid
           co2ice(ig) = 0.
@@ -668,9 +1289,8 @@
       ENDDO ! of DO ig=1,ngrid
 
-! We put the correct thickness of water ice given the slope
-      DO ig = 1,ngrid 
-          qsurf(ig,6) = 0.
+      DO ig = 1,ngrid !!!!! TO DOC GHANGE IF QSURF ?ü!?!?!?
+          qsurf(ig,igcm_h2o_ice) = 0.
              DO islope = 1,nslope
-                 qsurf(ig,6) = qsurf(ig,6) + qsurf_slope(ig,6,islope) &
+                 qsurf(ig,igcm_h2o_ice) = qsurf(ig,igcm_h2o_ice) + qsurf_slope(ig,igcm_h2o_ice,islope) &
                             * subslope_dist(ig,islope) /          &
                            cos(pi*def_slope_mean(islope)/180.)
@@ -680,12 +1300,67 @@
 
 
+
+! III_a.2 Tsurf and Tsoil update
+
+
+   call interpolate_TIPEM_TIGCM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_PEM,TI_GCM_phys)
+   tsoil_slope(:,:,:) = tsoil_phys_PEM_timeseries(:,:,:,timelen)
+
+
+      DO ig = 1,ngrid
+          tsurf(ig) = 0.
+          
+             DO islope = 1,nslope
+                 tsurf(ig) = tsurf(ig) + tsurf_slope(ig,islope) &
+                            * subslope_dist(ig,islope)      
+             ENDDO
+      ENDDO ! of DO ig=1,ngrid
+
+      DO ig = 1,ngrid
+         DO iloop = 1,nsoilmx
+          tsoil(ig,iloop) = 0.
+          inertiesoil(ig,iloop) = 0.
+             DO islope = 1,nslope
+                  tsoil(ig,iloop) =  tsoil(ig,iloop) + tsoil_slope(ig,iloop,islope) &
+                            * subslope_dist(ig,islope)   
+                  inertiesoil(ig,iloop) =  inertiesoil(ig,iloop) + TI_GCM_phys(ig,iloop,islope) &
+                            * subslope_dist(ig,islope)         
+             ENDDO
+          ENDDO
+      ENDDO ! of DO ig=1,ngrid
+
+! III_a.3 Surface optical properties
+
+    DO ig = 1,ngrid
+       DO l = 1,2
+        albedo(ig,l) =0. 
+        DO islope = 1,nslope
+          albedo(ig,l)= albedo(ig,l)+albedo_slope(ig,l,islope) &
+                         *subslope_dist(ig,islope) 
+        ENDDO
+       ENDDO
+      ENDDO
+
+
+    DO ig = 1,ngrid
+
+        emis(ig) =0. 
+        DO islope = 1,nslope
+          emis(ig)= emis(ig)+emiss_slope(ig,islope) &
+                         *subslope_dist(ig,islope) 
+        ENDDO
+       ENDDO
+      
+
+
 !------------------------
 
 ! III Output
-!    III_a Write startfi.nc
-
-!------------------------
-
-!----------------------------WRITE restart.nc ---------------------
+!    III_a Recomp tendencies for the start and startfi
+!    III_b Write start and starfi.nc
+
+!------------------------
+
+! III_b.1 WRITE restart.nc 
 
       ptimestep=iphysiq*daysec/REAL(day_step)/nsplit_phys
@@ -693,44 +1368,66 @@
       ztime_fin=0.
 
+         print *, "RVip1jmp1", ip1jmp1
      allocate(p(ip1jmp1,nlayer+1))
-     CALL pression (ip1jmp1,ap,bp,ps,p)
-     CALL massdair(p,masse)
-
-     day_ini=year
-
-     CALL dynredem0("restart_evol.nc", day_ini, phis)
-
-     CALL dynredem1("restart_evol.nc",   &
+         print *, "ngrid", ngrid
+         print *, "nlayer", nlayer
+          CALL pression (ip1jmp1,ap,bp,ps,p)
+     print *, "masse 1", masse(1,:)
+          CALL massdair(p,masse)
+     print *, "masse 2", masse(1,:)
+
+     do nnq=1,nqtot
+        call gr_fi_dyn(llm,ngridmx,iip1,jjp1,q_phys(:,:,nnq),q(:,:,nnq))
+     enddo
+
+
+      CALL dynredem0("restart_evol.nc", day_ini, phis)
+
+      CALL dynredem1("restart_evol.nc",   &
       		time_0,vcov,ucov,teta,q,masse,ps)
 
 
-!----------------------------WRITE restartfi.nc ---------------------
-
-     pday=year
-
-     call physdem0("restartfi_evol.nc",longitude,latitude, &
-                     nsoilmx,ngrid,nlayer,nq,              &
-                     ptimestep,pday,0.,cell_area,          &
-                     albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe, &
-                     hmons,summit,base,nslope,def_slope,   &
-                     subslope_dist)
-
-    call physdem1("restartfi_evol.nc",nsoilmx,ngrid,nlayer,nq,   &
+! III_b.2 WRITE restartfi.nc 
+
+      
+             call physdem0("restartfi_evol.nc",longitude,latitude, &
+                        nsoilmx,ngrid,nlayer,nq,              &
+                        ptimestep,pday,0.,cell_area,          &
+                        albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe, &
+                        hmons,summit,base,nslope,def_slope,   &
+                        subslope_dist)
+
+
+          call physdem1("restartfi_evol.nc",nsoilmx,ngrid,nlayer,nq,  &
                      ptimestep,ztime_fin,                        &
                      tsurf,tsoil,co2ice,albedo,emis,             &
                      q2,qsurf,tauscaling,totcloudfrac,wstar,     &
-                     watercap,nslope,co2ice_slope,               &
+                     watercap,inertiesoil,nslope,co2ice_slope,   &
                      tsurf_slope,tsoil_slope, albedo_slope,      &
-                     emiss_slope,qsurf_slope,watercap_slope)
-
-
-      print *, "RV : So far so good"
-
-
-
-
-      deallocate(longitude)
-      deallocate(latitude)
-      deallocate(cell_area)
+                     emiss_slope,qsurf_slope,watercap_slope, TI_GCM_phys)
+
+
+!------------------------
+
+! III Output
+!    III_a Recomp tendencies for the start and startfi
+!    III_b Write start and starfi.nc
+!    III_c Write start_pem
+
+!------------------------
+
+  
+
+         call pemdem1("restartfi_PEM.nc",ztime_fin,nsoilmx_PEM,ngrid,nslope , &
+                      tsoil_PEM, TI_PEM, ice_depth,co2_adsorbded_phys)
+
+
+ 
+
+      print *, "LL & RV : So far so good"
+
+
+
+
 
 
